//
//  $Log: Envoy.h,v $
//  Revision 1.3  1994/07/12  23:18:49  hakan
//  Stringnode added
//
//  Revision 1.2  1994/06/19  16:08:00  hakan
//  Most definitions included
//
//



#define MAXNAME     40



typedef struct _String
{
    struct Node t_node;

    char        String [MAXNAME];
}
String;



typedef struct _Realm
{
    struct Node r_node;

    char        RealmName [MAXNAME];
}
Realm;



typedef struct _Host
{
    struct Node h_node;

    char        HostName [MAXNAME];
    char        Owner [MAXNAME];
    long        IPAddr;
    long        ATTNFlags;
    long        ChipRevBits;
    long        AvailFastMem;
    long        MaxFastMem;
    long        AvailChipMem;
    long        MaxChipMem;
    long        KickVersion;
    long        WBVersion;
    long        NIPCVersion;

    struct List Entities;
    struct List Services;

}
Host;




#define NP_HostName         (1L <<  0)
#define NP_Owner            (1L <<  1)
#define NP_IPAddr           (1L <<  2)
#define NP_ATTNFlags        (1L <<  3)
#define NP_ChipRevBits      (1L <<  4)
#define NP_AvailFastMem     (1L <<  5)
#define NP_MaxFastMem       (1L <<  6)
#define NP_AvailChipMem     (1L <<  7)
#define NP_MaxChipMem       (1L <<  8)
#define NP_KickVersion      (1L <<  9)
#define NP_WBVersion        (1L << 10)
#define NP_NIPCVersion      (1L << 11)
#define NP_Entities         (1L << 12)
#define NP_Services         (1L << 13)

#define NP_402_Kludge       (1L << 14)

#define NP_SingleHost       (1L << 15)
