//
//  $Log: extern.h $
//  Revision 1.2  1994/08/10  09:51:46  hakan
//  function SaveFile added
//
//  Revision 1.1  1994/07/12  23:20:38  hakan
//  Initial revision
//
//
//  External functions
//



#include "Envoy.h"


extern long     NP_Config;
extern long     NP_ScanTime;
extern long     NP_ScanPackets;
extern char*    NP_ScanHost;


extern char*        getVersString (void);
extern char*        getAboutVersionString (void);
extern char*        getWindowVersionString (void);
extern char*        getVersTag (void);

extern BOOL         CreateTimer (void);
extern void         DestroyTimer (void);
struct IORequest*   TimeRequest (void);
struct MsgPort*     TimePort (void);

extern BOOL         CreateEnvoy (void);
extern void         DestroyEnvoy (void);
extern BOOL         RealmServerRunning (void);
extern struct List* Hosts (void);
extern struct List* Realms (void);
extern Host*        getHost (char* name);
extern void         ScanRealms (void);
extern void         ScanHosts (char* realmname);
extern void         ScanAll (void);
extern void         ScanPing (void);

extern char*        DecodeATTNFlags (long flags);
extern char*        DecodeChipRevBits (long flags);
extern void         SaveList (char* FileName);

BOOL CreateUI       (int argc, char* argv[]);
void DestroyUI      (void);
void EventLoop      (void);
BOOL OpenScanWindow (long max);
void CloseScanWindow (void);
BOOL ShowScan       (long current);
